
void draw() {
  
    background(0); //refresh background
    
    textFont(myFont);
    
    
    stroke(255);
    strokeWeight(0.5);
    
    if (!r.getState("Sorted")) {
        background(0);
        for (int i=0; i<rowNum; i++) {
            for (int j=0; j<colNum; j++) {
                int fillR = colorbrewerG[colorbrewerSelect(dataMatrix[i][j])][0];
                int fillG = colorbrewerG[colorbrewerSelect(dataMatrix[i][j])][1];
                int fillB = colorbrewerG[colorbrewerSelect(dataMatrix[i][j])][2];
                fill(fillR,fillG,fillB);
                rect(rowMargin-9*5+i*cellWidth+(i/10)*5,colMargin+j*cellHeight,cellWidth,cellHeight);
                
              fill(255);
              if (mouseX>rowMargin-9*5+i*cellWidth+(i/10)*5 && mouseX < rowMargin-9*5+(i+1)*cellWidth+((i)/10)*5 && mouseY>colMargin+j*cellHeight && mouseY<colMargin+(j+1)*cellHeight) {
                  if ((i*10+j)<10) {
                      text("Dewey Class: " + "00" + (i*10+j), rowMargin, height - colMargin/2);
                  } else if ((i*10+j)>=10 && (i*10+j)<100) {
                      text("Dewey Class: " + "0" + (i*10+j), rowMargin, height - colMargin/2);
                  } else {
                      text("Dewey Class: " + (i*10+j), rowMargin, height - colMargin/2);
                  }
                  
              }
       
            }
        }
    }
    //background(0);
    if (r.getState("Sort")) {
        background(0);
        for (int i=0; i<rowNumSorted; i++) {
            for (int j=0; j<colNumSorted; j++) {
                int fillR = colorbrewerG[colorbrewerSelect(sortedDataMatrix[i][j])][0];
                int fillG = colorbrewerG[colorbrewerSelect(sortedDataMatrix[i][j])][1];
                int fillB = colorbrewerG[colorbrewerSelect(sortedDataMatrix[i][j])][2];
                fill(fillR,fillG,fillB);
                rect(rowMargin-9*5+i*cellWidth+(i/10)*5,colMargin+j*cellHeight,cellWidth,cellHeight);
       
            }
        }
        for (int i=0; i<rowNumIndex; i++) {
            for (int j=0; j<colNumIndex; j++) {
                fill(255);
              if (mouseX>rowMargin-9*5+i*cellWidth+(i/10)*5 && mouseX < rowMargin-9*5+(i+1)*cellWidth+((i)/10)*5 && mouseY>colMargin+j*cellHeight && mouseY<colMargin+(j+1)*cellHeight) {
                  if ((i*10+sortedIndexMatrix[i][j])<10) {
                      text("Dewey Class: " + "00" + (int)(i*10+sortedIndexMatrix[i][j]), rowMargin, height - colMargin/2);
                  } else if ((i*10+sortedIndexMatrix[i][j])>=10 && (i*10+sortedIndexMatrix[i][j])<100) {
                      text("Dewey Class: " + "0" + (int)(i*10+sortedIndexMatrix[i][j]), rowMargin, height - colMargin/2);
                  } else {
                      text("Dewey Class: " + (int)(i*10+sortedIndexMatrix[i][j]), rowMargin, height - colMargin/2);
                  }
                  
              }
       
            }
        }
        
    }

    textFont(myFont, 7);
    
    for (int i=0; i<8; i++){
        fill(colorbrewerG[i][0],colorbrewerG[i][1],colorbrewerG[i][2]);
        rect(width-rowMargin+3*cellWidth, height-colMargin-5-7*(7-i), 30, 5);
    }
    
    fill(255);
    text(">=113", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*7);
    text("71 - 113", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*6);
    text("59 - 71", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*5);
    text("52 - 59", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*4);
    text("46 - 52", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*3);
    text("40 - 46", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*2);
    text("0 - 40", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*1);
    text("No Data", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*0);
    text("Legend", width-rowMargin+3*cellWidth+13, height-colMargin-3-60);
    
    textFont(myFont, 30);
    
    text("Average Checkout Duration of Dewey Classification", width/2, colMargin/2);


}

